#! /bin/sh
# Copyright 2011 Nicolas Limare <nicolas.limare@cmla.ens-cachan.fr>
#
# Copying and distribution of this file, with or without
# modification, are permitted in any medium without royalty provided
# the copyright notice and this notice are preserved.  This file is
# offered as-is, without any warranty.

set -e

MAKE="make --no-print-directory" 

$MAKE distclean > /dev/null 2>&1
$MAKE cpucycles

for CC in gcc clang icc pathcc suncc; do
    (which $CC | sed 's/^/# /') || continue
    case $CC in
	"gcc")
	    CFLAGS="-fomit-frame-pointer -march=native -mtune=native"
	    COPT_LIST="-O1 -O2 -O3"
	    ;;
	"clang")
	    CFLAGS="-march=native"
	    COPT_LIST="-O1 -O2 -O3"
	    ;;
	"icc")
	    CFLAGS="-fomit-frame-pointer -xHost -fp-model precise"
	    COPT_LIST="-O1 -O2 -O3"
	    ;;
	"pathcc")
	    CFLAGS="-fomit-frame-pointer"
	    COPT_LIST="-O1 -O2 -O3"
	    ;;
	"suncc")
	    CFLAGS=""
	    COPT_LIST="-O1 -O2 -O3 -fast"
	    ;;
	*)
	    CFLAGS=""
	    COPT_LIST="-O"
	    ;;
    esac
    for COPT in $COPT_LIST; do
	$MAKE clean > /dev/null 2>&1
	$MAKE CC=$CC CFLAGS="$CFLAGS" COPT=$COPT build | sed 's/^/# /'
	$MAKE count
    done
done

